
<p>Potpuno zbrajalo je komponenta (kombinacijski sklop) koji na ulazima prima dvije znamenke i ulazni prijenos (koji može biti 0 ili 1) te računa njihovu sumu i izlazni prijenos.</p>

<p>Pogledajmo najprije primjer u dekadskom brojevnom sustavu. Zbrajanjem znamenaka 3 i 4 i ulaznog prijenosa 0 dobivamo rezultat 7 i izlazni prijenos 0. Zbrajanjem znamenaka 3 i 4 i ulaznog prijenosa 1 dobivamo rezultat 8 i izlazni prijenos 0. Zbrajanjem znamenaka 6 i 7 i ulaznog prijenosa 0 dobivamo rezultat 3 i izlazni prijenos 1.</p>

<p>Kao što smo to učinili kod poluzbrajala, i ovdje ćemo pokazati da kod potpunog zbrajala izlazni prijenos može biti isključivo 0 ili 1, neovisno o bazi u kojoj se provodi zbrajanje. Naime, minimalne vrijednosti pribrojnika su 0 i 0 a ulaznog prijenosa također 0; njihov ukupni zbroj je 0, pa su tada i znamenka rezultata i prijenos jednaki 0. Ako su pribrojnici i ulazni prijenos maksimalnih vrijednosti, onda zbrajamo znamenke <i>B</i>-1 i <i>B</i>-1 te ulazni prijenos 1, što je \((B-1)+(B-1)+1 = 2 \cdot B - 1\) odnosno \(B + (B-1)\) što je zapravo \(1 \cdot B^1 + (B-1) \cdot B^0\), pa je znamenka rezultata jednaka <i>B-1</i> (maksimalna u bazi) a prijenos jednak 1. U dekadskom brojevnom sustavu, takvu situaciju imamo kada zbrajamo 9 i 9 i ulazni prijenos 1; suma je 19 pa je znamenka rezultata 9 a prijenos 1. Uočite da je nemoguće da suma dvije dekadske znamenke i ulaznog prijenosa bude 20 ili veća (čime bismo imali prijenos 2 ili veći).</p> 

<p>Interaktivna simulacija dekadskog potpunog zbrajala prikazana je u nastavku. Pribrojnike i ulazni prijenos možete mijenjati klikom miša (lijevi klik: inkrement, desni klik: dekrement) ili povlačenjem (u lijevu stranu: smanjivanje, u desnu: povećavanje; iznos ovisi o tome koliko daleko povučete). Sklop je trenutno podešen tako da su mu pribrojnici 2 i 3.</p>

<p>Pribrojnici su na simbolu sklopa označeni s <i>a</i> i <i>b</i>, ulazni prijenos s <i>c</i><sub>in</sub> (od engleskog <i>carry<sub>input</sub></i>), znamenka rezultata s <i>r</i> a prijenos s <i>c</i><sub>out</sub>. U središtu simbola upisano je FA od engleskog <i>Full-adder</i>, odnosno <em>potpuno zbrajalo</em>.</p>

<script>
@#page-include#(adders.js)
</script>

<div style="text-align: center;">
<canvas id="myCanvas1" width="220" height="230" oncontextmenu="return false;"></canvas><br>
Dekadsko potpuno zbrajalo.
</div>

<script>
// Prvi primjer:
var addState1 = new additionState(1);
addState1.a[0].setValue(2);
addState1.b[0].setValue(3);

var model1 = [
  new adder("myCanvas1", addState1, 0, 10, true)
];

model1[0].offsetX = 20;
model1[0].showABLabels = false;
model1[0].cinState = 3;

var sc1 = new scene("myCanvas1", model1, addState1);
sc1.drawAll();
</script>

<p>Dekadsko potpuno zbrajalo je kombinacijski sklop čiji je rad u potpunosti određen tablicom od 200 redaka, u kojoj za svaku vrijednost od <i>a</i> i svaku vrijednost od <i>b</i> i svaku vrijednost ulaznog prijenosa piše koja je znamenka rezultata a koji prijenos. Kako za <i>a</i> imamo 10 mogućnosti (znamenke su od 0 do 9) i kako za <i>b</i> imamo 10 mogućnosti (znamenke od 0 do 9) i kako za ulazni prijenos imamo 2 mogućnosti (0 i 1), ukupan broj kombinacija je \(10 \times 10 \times 2 = 200\). Djelomični prikaz ove tablice dan je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica dekadskog potpunog zbrajala.</div>
<table class="mlTableCC mlTableVRl2">
<thead>
<tr><th><i>a</i></th><th><i>b</i></th><th><i>c<sub>out</sub></i></th><th><i>r</i></th><th><i>c<sub>out</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>2</td><td>0</td></tr>
<tr><td>0</td><td>2</td><td>0</td><td>2</td><td>0</td></tr>
<tr><td>0</td><td>2</td><td>1</td><td>3</td><td>0</td></tr>
<tr><td>0</td><td>3</td><td>0</td><td>3</td><td>0</td></tr>
<tr><td>0</td><td>3</td><td>1</td><td>4</td><td>0</td></tr>
<tr><td>0</td><td>4</td><td>0</td><td>4</td><td>0</td></tr>
<tr><td>0</td><td>4</td><td>1</td><td>5</td><td>0</td></tr>
<tr><td>0</td><td>5</td><td>0</td><td>5</td><td>0</td></tr>
<tr><td>0</td><td>5</td><td>1</td><td>6</td><td>0</td></tr>
<tr><td>0</td><td>6</td><td>0</td><td>6</td><td>0</td></tr>
<tr><td colspan="3">...</td><td>...</td><td>...</td></tr>
<tr><td>9</td><td>8</td><td>1</td><td>8</td><td>1</td></tr>
<tr><td>9</td><td>9</td><td>0</td><td>8</td><td>1</td></tr>
<tr><td>9</td><td>9</td><td>1</td><td>9</td><td>1</td></tr>
</tbody>
</table>
 
<p>Kvartarno potpuno zbrajalo je potpuno zbrajalo za brojevni sustav s bazom <i>B</i>=4. Interaktivna simulacija takvog zbrajala prikazana je nastavku. Isprobajte njegov rad.</p>

<div style="text-align: center;">
<canvas id="myCanvas2" width="220" height="230" oncontextmenu="return false;"></canvas><br>
Kvartarno potpuno zbrajalo.
</div>

<script>
// Prvi primjer:
var addState2 = new additionState(1);
addState2.a[0].setValue(1);
addState2.b[0].setValue(2);

var model2 = [
  new adder("myCanvas2", addState2, 0, 4, true)
];

model2[0].offsetX = 20;
model2[0].showABLabels = false;
model2[0].cinState = 3;

var sc2 = new scene("myCanvas2", model2, addState2);
sc2.drawAll();
</script>

<p>Početak tablice koja opisuje rad ovog potpunog zbrajala prikazana je u nastavku. Čitava tablica ima \(4 \times 4 \times 2 = 32\) retka.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 2.</span> Tablica kvartarnog potpunog zbrajala.</div>
<table class="mlTableCC mlTableVRl2">
<thead>
<tr><th><i>a</i></th><th><i>b</i></th><th><i>c<sub>in</sub></i></th><th><i>r</i></th><th><i>c<sub>out</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>2</td><td>0</td></tr>
<tr><td>0</td><td>2</td><td>0</td><td>2</td><td>0</td></tr>
<tr><td>0</td><td>2</td><td>1</td><td>3</td><td>0</td></tr>
<tr><td>0</td><td>3</td><td>0</td><td>3</td><td>0</td></tr>
<tr><td>0</td><td>3</td><td>1</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>2</td><td>0</td></tr>
<tr><td colspan="3">...</td><td>...</td><td>...</td></tr>
</tbody>
</table>

<p>Binarno potpuno zbrajalo je potpuno zbrajalo za brojevni sustav s bazom <i>B</i>=2. Moguće znamenke su samo 0 i 1. Interaktivna simulacija takvog zbrajala prikazana je nastavku. Isprobajte njegov rad.</p>

<div style="text-align: center;">
<canvas id="myCanvas3" width="220" height="230" oncontextmenu="return false;"></canvas><br>
Binarno potpuno zbrajalo.
</div>

<script>
// Prvi primjer:
var addState3 = new additionState(1);
addState3.a[0].setValue(0);
addState3.b[0].setValue(0);

var model3 = [
  new adder("myCanvas3", addState3, 0, 2, true)
];

model3[0].offsetX = 20;
model3[0].showABLabels = false;
model3[0].cinState = 3;

var sc3 = new scene("myCanvas3", model3, addState3);
sc3.drawAll();
</script>

<p>Tablica koja opisuje funkcionalnost binarnog potpunog zbrajala prikazana je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 3.</span> Tablica binarnog potpunog zbrajala.</div>
<table class="mlTableCC mlTableVRl2">
<thead>
<tr><th><i>a</i></th><th><i>b</i></th><th><i>c<sub>in</sub></i></th><th><i>r</i></th><th><i>c<sub>out</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>1</td><td>1</td><td>1</td><td>1</td></tr>
</tbody>
</table>

<p>Kod binarnog potpunog zbrajala svi ulazi i izlazi su jednobitne vrijednosti. Iz tog razloga, sklop možemo promatrati kao vektorsku Booleovu funkciju koja preslikava \((a,b,c_{\text{in}}) \rightarrow (r,c_{\text{out}})\). Komponente \(r\) i \(c_{\text{out}}\) određene su izrazima danim u nastavku, što je izravno vidljivo iz prethodno prikazane tablice istinitosti.
$$
r(a,b,c_{\text{in}}) = a \oplus b \oplus c_{\text{in}} \\
c_{\text{out}}(a,b,c_{\text{in}}) = a \cdot b + c_{\text{in}} \cdot (a \oplus b).
$$
</p>

<div class="mlImportant">
<p>Binarno potpuno zbrajalo važno je za razumijevanje izgradnje višeznamenkastog binarnog zbrajala. Provjerite jeste li shvatili njegovu funkciju te algebarske izraze kojima su opisani njegovi izlazi. Zapamtite te algebarske izraze (ili bolje: način na koji smo došli do njih).</p>
</div>

<h3>Digitalna izvedba potpunog zbrajala za <i>B</i>&gt;2</h3>

<p>Za manje vrijednosti baze ovom problemu možemo pristupiti na jednak način kao što smo to učinili za poluzbrajalo. Međutim, u slučajevima da je kôd kojim se kodiraju znamenke pogodan, projektiranju se može pristupiti i drugačije, što ćemo pojasniti na predavanju.</p>

